require 'sinatra'

get '/authorize' do
  haml :login
end

post '/authorize' do
  redirect_url = params[:redirect_uri] || params[:redirect_url]
  @username = params[:username]
  grant = Rxuniverse::API.cobol.run(:login, [@username, params[:password]])
  json = JSON.parse(grant)
  if json['result'] == 'successful'
    if redirect_url
      begin
        parsed_url = URI(redirect_url)
        parsed_url.query = [*(parsed_url.query || "").split("&"), "code=#{json['authorization_grant']}", params[:state] && "state=#{params[:state]}"].select{|s| s}.join("&")
        redirect parsed_url.to_s
      rescue StandardError => err
        @error = err.message
        haml :login
      end
    else
      JSON.pretty_generate(json)
    end
  else
    @error = json['result']
    haml :login
  end
end

post '/token' do
  token_info = Rxuniverse::API.cobol.run(:get_token, [params[:code]])
  json = JSON.parse(token_info)
  json.delete 'result'
  JSON.generate(json)
end

post '/refresh' do
  token_info = Rxuniverse::API.cobol.run(:refresh_token, [params[:code]])
  json = JSON.parse(token_info)
  json.delete 'result'
  JSON.generate(json)
end